%%% changes from 0.2 : added in proper microphone ratios

clear all
close all
clc

disp('')
disp('201.7 mm length begin')
disp('')


spl=load('Collected Samples/mic_volt_201_7_300.txt');

m1c=1;

ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

for k=1:4
    for j=1:length(spl)
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end

    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y1 = fft(spl(:,m1c),np);      % DFT
        f1 = (0:np-1)*(fs/np);      % Frequency range
        power1 = y1.*conj(y1)/np;     % Power of the DFT
        [mx ind]=max(power1);
        frq=f1(ind);
        pw1=mx;

    

for i=310:10:2000;
    p4th=['Collected Samples/mic_volt_201_7_' num2str(i) '.txt'];
    spl=load(p4th);
    
    ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

for k=1:4
    for j=1:length(spl)
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end
    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y = fft(spl(:,m1c),np);      % DFT
        f = (0:np-1)*(fs/np);      % Frequency range
        power = y.*conj(y)/np;     % Power of the DFT
        %concatenate
        [mx ind]=max(power);
                if f(ind)>i+10 || f(ind)<i-10
                    disp(['Warning: forcing frq not largest at ', num2str(i), ' Hz'])
                    %finding frequency closest to i
                    tar=find(f<i+10 & f>i-10);
                    [mx ind]=max(power(tar));                     
                    ind=ind+tar(1)-1;
                    disp([' max:', num2str(mx), ' ind:', num2str(ind), ' frq:', num2str(f(ind))])
                end
        if f(ind)>30
        frq=[frq, f(ind)];
        pw1=[pw1, mx];
        end
        

    
end



    h_freqs202=[440, 864, 1291, 1719];
    w_freqs202=[854,1703];
    d_freqs202=[1144];
    
    [h1x h1]=spike_gen(h_freqs202, max(pw1));
    [w1x w1]=spike_gen(w_freqs202, max(pw1));
    [d1x d1]=spike_gen(d_freqs202, max(pw1));

figure(1)
plot(frq,pw1);
hold all
title('Combined SPL Power Spectrum for 202mm')
xlabel('Frequency [Hz]')
ylabel('Power');

% plot(h1x,h1)
% plot(w1x,w1)
% plot(d1x,d1)


legend('300-2000 Hz Scan','Z-axial mode locations','X-axial mode locations','Y-axial mode locations')
axis([0 2100 0 max(pw1)])

hold off

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


disp('')
disp('857.5 mm length begin')
disp('')

spl=load('Collected Samples/mic_volt_857_5_300.txt');

ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

for k=1:4
    for j=1:length(spl)
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end

    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y1 = fft(spl(:,m1c),np);      % DFT
        f1 = (0:np-1)*(fs/np);      % Frequency range
        power1 = y1.*conj(y1)/np;     % Power of the DFT
        [mx ind]=max(power1);
        frq=f1(ind);
        pw1=mx;

    




for i=310:10:2000;
    p4th=['Collected Samples/mic_volt_857_5_' num2str(i) '.txt'];
    spl=load(p4th);
    
    ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

for k=1:4
    for j=1:length(spl)
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end

    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y = fft(spl(:,m1c),np);      % DFT
        f = (0:np-1)*(fs/np);      % Frequency range
        power = y.*conj(y)/np;     % Power of the DFT
        %concatenate
        [mx ind]=max(power);
                if f(ind)>i+10 || f(ind)<i-10
                    disp(['Warning: forcing frq not largest at ', num2str(i), ' Hz'])
                    %finding frequency closest to i
                    tar=find(f<i+10 & f>i-10);
                    [mx ind]=max(power(tar));                     
                    ind=ind+tar(1)-1;
                    disp([' max:', num2str(mx), ' ind:', num2str(ind), ' frq:', num2str(f(ind))])
                end
        if f(ind)>30
        frq=[frq, f(ind)];
        pw1=[pw1, mx];
        end

    
end
%%%%% ADDITIONAL MEASUREMENTS, VOLTS END %%%%%% 

    h_freqs858=[440, 864, 1291, 1719];
    w_freqs858=[213, 406, 604, 803, 1003, 1202, 1402, 1601, 1801, 2001];
    d_freqs858=[1144];
    
    [h1x h1]=spike_gen(h_freqs858, max(pw1));
    [w1x w1]=spike_gen(w_freqs858, max(pw1));
    [d1x d1]=spike_gen(d_freqs858, max(pw1));


figure(2)
plot(frq,pw1);
hold all
title('Combined SPL Power Spectrum for 858mm')
xlabel('Frequency [Hz]')
ylabel('Power');

% plot(h1x,h1)
% plot(w1x,w1)
% plot(d1x,d1)


legend('300-2000 Hz Scan','Z-axial mode locations','X-axial mode locations','Y-axial mode locations')
axis([0 2100 0 max(pw1)])
hold off

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


disp('')
disp('440 mm length begin')
disp('')
spl=load('Collected Samples/mic_volt_440_300.txt');

ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

for k=1:4
    for j=1:length(spl)
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end


    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y1 = fft(spl(:,m1c),np);      % DFT
        f1 = (0:np-1)*(fs/np);      % Frequency range
        power1 = y1.*conj(y1)/np;     % Power of the DFT
        [mx ind]=max(power1);
        frq=f1(ind);
        pw1=mx;




    



for i=310:10:2000;
    p4th=['Collected Samples/mic_volt_440_', num2str(i), '.txt'];
    spl=load(p4th);
    
    ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS


aaa=size(spl);
for k=1:4
    for j=1:aaa(1);
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end


    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y = fft(spl(:,m1c),np);      % DFT
        f = (0:np-1)*(fs/np);      % Frequency range
        power = y.*conj(y)/np;     % Power of the DFT
        %concatenate
        [mx ind]=max(power);
                if f(ind)>i+10 || f(ind)<i-10 && mx~=0
                    disp(['Warning: forcing frq not largest at ', num2str(i), ' Hz'])
                    %finding frequency closest to i
                    tar=find(f<i+10 & f>i-10);
                    [mx ind]=max(power(tar));                     
                    ind=ind+tar(1)-1;
                    disp([' max:', num2str(mx), ' ind:', num2str(ind), ' frq:', num2str(f(ind))])
                end
        if f(ind)>30
        frq=[frq, f(ind)];
        pw1=[pw1, mx];
        end

    
end
%%%%% ADDITIONAL MEASUREMENTS, VOLTS END %%%%%% 
figure(3)
hold all
plot(frq,pw1);
title('Combined SPL Power Spectrum for 440mm')
xlabel('Frequency [Hz]')
ylabel('Power');
legend('300-2000 Hz Scan')
axis([0 2100 0 max(pw1)])

    h_freqs440=[440, 864, 1291, 1719];
    w_freqs440=[396,783,1172,1562,1951];
    d_freqs440=[1144];
    
    [h1x h1]=spike_gen(h_freqs440, max(pw1));
    [w1x w1]=spike_gen(w_freqs440, max(pw1));
    [d1x d1]=spike_gen(d_freqs440, max(pw1));

% plot(h1x,h1)
% plot(w1x,w1)
% plot(d1x,d1)


legend('300-2000 Hz Scan','Z-axial mode locations','X-axial mode locations','Y-axial mode locations')
axis([0 2100 0 max(pw1)])

hold off
