clear all
close all
clc

%%% Update from 0.2 : now uses rms, and changed to adjusted microphone
%%% mv/Pa ratio.  Also changed source microphone to 2 for 444mm and 858mm,
%%% and microphone 4 for 202mm

spl=load('Freq_scan_08_04_2014\volt_201_7_300.txt');

ratio=[1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

m1c=4;
pw1=[0 0];
for k=1:4
    for j=1:length(spl)
        spl(j,k)=spl(j,k)*1000/ratio(k);
    end
end


    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y1 = fft(spl(:,m1c),np);      % DFT
        f1 = (0:np-1)*(fs/np);      % Frequency range
        power1 = y1.*conj(y1)/np;     % Power of the DFT
        [mx ind]=max(power1);
        frq=f1(ind);
        pw1=mx;


    

for i=310:10:2000;
    p4th=['Freq_scan_08_04_2014\volt_201_7_' num2str(i) '.txt'];
    spl=load(p4th);
    
    ratio=[1.527,1.504,1.695,1.465];
    %ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

    for k=1:4
        for j=1:length(spl)
           spl(j,k)=spl(j,k)*1000/ratio(k);
        end
    end


    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y = fft(spl(:,4),np);      % DFT
        f = (0:np-1)*(fs/np);      % Frequency range
        power = y.*conj(y)/np;     % Power of the DFT
        %concatenate
        [mx ind]=max(power);
        disp([' maximum ' num2str(mx), ', found at', num2str(f(ind)), 'Hz'])
        frq=[frq, f(ind)];
        pw1=[pw1, mx];
        

    
end

    h_freqs202=[214, 643, 1072, 1715, 1931];
    w_freqs202=[877,1931];
    d_freqs202=[1163];
    
    [h1x h1]=spike_gen(h_freqs202, max(pw1));
    [w1x w1]=spike_gen(w_freqs202, max(pw1));
    [d1x d1]=spike_gen(d_freqs202, max(pw1));

figure(1)
plot(frq,pw1);
hold all
title('Combined SPL Power Spectrum for 202mm')
xlabel('Frequency [Hz]')
ylabel('Power');
plot(h1x,h1)
plot(w1x,w1)
plot(d1x,d1)

legend('300-2000 Hz Scan','Z-axial mode locations','Quasi-x-axial mode locations','Quasi-y-axial mode locations')
axis([0 2100 0 max(pw1)])
hold off

spl=load('Freq_Scan_10_04_2014\volt_858_300.txt');

    ratio=[1.527,1.504,1.695,1.465];
    %ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS
    
    
    for k=1:4
        for j=1:length(spl)
           spl(j,k)=spl(j,k)*1000/ratio(k);
        end
    end
    
    
    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y1 = fft(spl(:,m1c),np);      % DFT
        f1 = (0:np-1)*(fs/np);      % Frequency range
        power1 = y1.*conj(y1)/np;     % Power of the DFT
        [mx ind]=max(power1);
        frq=f1(ind);
        pw1=mx;

for i=310:10:2000;
    p4th=['Freq_Scan_10_04_2014\volt_858_' num2str(i) '.txt'];
    spl=load(p4th);
    
        ratio=[1.527,1.504,1.695,1.465];
    %ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

    for k=1:4
        for j=1:length(spl)
           spl(j,k)=spl(j,k)*1000/ratio(k);
        end
    end
    
    
    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y = fft(spl(:,2),np);      % DFT
        f = (0:np-1)*(fs/np);      % Frequency range
        power = y.*conj(y)/np;     % Power of the DFT
        %concatenate
        [mx ind]=max(power);
                if f1(ind)>i+20
                    disp('[Warning: forcing frq not largest at ', num2str(i), ' Hz'])
                    [mx ind]=max(power(1:(ind-20)));
                end
        frq=[frq, f(ind)];
        pw1=[pw1, mx];
    
end
    
    h_freqs858=[214, 643, 1072, 1501, 1931];
    w_freqs858=[293, 454, 637, 828, 1023, 1219, 1416, 1614, 1812];
    d_freqs858=[1164];
    
    [h1x h1]=spike_gen(h_freqs858, max(pw1));
    [w1x w1]=spike_gen(w_freqs858, max(pw1));
    [d1x d1]=spike_gen(d_freqs858, max(pw1));

figure(2)
hold all
plot(frq,pw1);
title('Combined SPL Power Spectrum for 858mm')
xlabel('Frequency [Hz]')
ylabel('Power');


plot(h1x,h1)
plot(w1x,w1)
plot(d1x,d1)

legend('300-2000 Hz Scan','Z-axial mode locations','Quasi-x-axial mode locations','Quasi-y-axial mode locations')
axis([0 2100 0 max(pw1)])

hold off

spl=load('Freq_scan_09_04_2014\volt_444_300.txt');
        ratio=[1.527,1.504,1.695,1.465];
    %ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

    for k=1:4
        for j=1:length(spl)
           spl(j,k)=spl(j,k)*1000/ratio(k);
        end
    end

    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y1 = fft(spl(:,m1c),np);      % DFT
        f1 = (0:np-1)*(fs/np);      % Frequency range
        power1 = y1.*conj(y1)/np;     % Power of the DFT
        [mx ind]=max(power1);
        frq=f1(ind);
        pw1=mx;
    

for i=310:10:2000;
    p4th=['Freq_scan_09_04_2014\volt_444_' num2str(i) '.txt'];
    spl=load(p4th);
    
        ratio=[1.527,1.504,1.695,1.465];
    %ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS

    for k=1:4
        for j=1:length(spl)
           spl(j,k)=spl(j,k)*1000/ratio(k);
        end
    end
    
    n=length(spl);
    dt=3.906250E-5;
    t=(0:n-1)*dt;

    
        fs=1/dt;                   %sample frequency
        np = pow2(nextpow2(n*20)); % Transform length
        y = fft(spl(:,2),np);      % DFT
        f = (0:np-1)*(fs/np);      % Frequency range
        power = y.*conj(y)/np;     % Power of the DFT
        %concatenate
        [mx ind]=max(power);
        frq=[frq, f(ind)];
        pw1=[pw1, mx];
end

    h_freqs444=[214, 643, 1071, 1501, 1931];
    w_freqs444=[442, 802, 1179, 1561, 1944];
    d_freqs444=[1164];
    
    [h1x h1]=spike_gen(h_freqs444, max(pw1));
    [w1x w1]=spike_gen(w_freqs444, max(pw1));
    [d1x d1]=spike_gen(d_freqs444, max(pw1));

figure(3)
hold all
plot(frq,pw1);
title('Combined SPL Power Spectrum for 440mm')
xlabel('Frequency [Hz]')
ylabel('Power');

plot(h1x,h1)
plot(w1x,w1)
plot(d1x,d1)

legend('300-2000 Hz Scan','Z-axial mode locations','Quasi-x-axial mode locations','Quasi-y-axial mode locations')
axis([0 2100 0 max(pw1)])
hold off