%1.2 Update: now with adjusted mv/pa ratios for the microphones
function [] = plot_h_zaxis_1_3(freq, width, lid)
clearvars -except freq width lid
close all
clc

if lid>0
    lidstr='lid';
else
    lidstr='lidless';
end


spl=load(['Z-axis study 25_04_2013/volt_', num2str(width),'_', num2str(freq),'Hz_',lidstr, '_bottom.txt']);
%comsol_x=load('total_acoustic_pressure_560mm_mic1_axis.txt');
comsol_z=abs(load('Z-axis study 25_04_2013/202_z-axis_lid.txt'));
spl2=load(['Z-axis study 25_04_2013/volt_', num2str(width),'_', num2str(freq),'Hz_',lidstr, '_top.txt']);

comsol_z(:,2)=comsol_z(:,2)/max(comsol_z(:,2));

%LENGTH EQUILIZING/SNIPPING%
if length(spl)>length(spl2)
    spl=spl(1:length(spl2),:);
else
    spl2=spl2(1:length(spl),:);
end
spl=[spl,spl2];

ratio=[1.527,1.504,1.695,1.465,1.527,1.504,1.695,1.465];
%ratio=[1.665,1.505,1.597,1.465,1.665,1.505,1.597,1.465];


for i=1:8
    for j=1:length(spl)
        spl(j,i)=spl(j,i)*1000/ratio(i);
    end
end

n=length(spl);
dt=3.906250E-5;
t=(0:n-1)*dt;

figure(1)
hold all
title('Time Plot, 202 mm chamber')
xlabel('t [s]')
ylabel('Acoustic Pressure [Pa]')

for i=1:4
plot(t,spl(:,i))
end
% legend('Microphone 1 (9mm)','Microphone 2 (140mm)','Microphone 3 (274mm)','Microphone 4 (408mm)')

hold off

figure(2)
hold all
title('Spectrum: Acoustic Pressure')
ylabel('Power')
xlabel('Frequency [Hz')

for i=1:8
    fs=1/dt;                   %sample frequency
    np = pow2(nextpow2(n*20)); % Transform length
    y = fft(spl(:,i),np);      % DFT
    f = (0:np-1)*(fs/np);      % Frequency range
    power = y.*conj(y)/np;     % Power of the DFT
    plot(f,power);
    %TEST
    mxpwr=find(power==max(power));
    ph4se(i)=(atan2(imag(y(mxpwr(1))),real(y(mxpwr(1)))));
end
hold off

rmss=zeros(4,1);
amp=0;
t_amp=0;

for i=1:8
    rmss(i)=std(spl(:,i));
end
diff=rmss(5)-rmss(1)
for i=1:4
    rmss(i)=rmss(i)+diff;
    disp('beep')
end

rmss=rmss/max(rmss);

l=[0.103 0.072 0.039 0.007 0.103 0.194 0.286 0.376];

%%%%%%%%%%%%%
disp('AMPLITUDES:')
disp(rmss)
%%%%%%%%%%%%%%%%

chaml=0.40;
lcham=[0,0.00001, 0.000011, chaml-0.00001, chaml, chaml-0.00001];
wall=max(rmss)*1.5;
cham=[0,wall,0,0,wall,0];

ltheo=[0:1000]*chaml/1000;
theo=abs(max(rmss)*cos(ltheo*2*pi/chaml));


figure(3)
plot(rmss(1:8),l(1:8),'x','MarkerSize',20)
hold all
% plot(rmss(5:8),l(5:8),'x','MarkerSize',20)
plot(cham, lcham)
% plot(ltheo,theo);
plot(comsol_z(:,2)*max(rmss),comsol_z(:,1))
title(['Amplitudes along Z-axis ', num2str(freq),' Hz, ', num2str(width), ' width,', lidstr])



xlabel('Normalised amplitude')
ylabel('length [m]')
legend('measured amplitudes 1','walls','Comsol wave amplitude shape')

%SAMPLE OF DATA FROM SAME instant
% samp=zeros(4,1);
% char=['+','o','*','h'];
% for j=1:4
%     
%     lgnd=['Wave sample at maximum of microphone ',num2str(j)];
%     figure(j+3)
%     plot(l,amps,'x','MarkerSize',20)
%     hold all
%     plot(lcham, cham)
% %     plot(ltheo,theo);
% %     plot(comsol_absp(:,1),comsol_absp(:,2)*max(amps)/max(comsol_absp(:,2)));
%     
%     [t_amp amp]=find_amp(t, spl(:,j));
%     
%     t_sample=t_amp(4);
%     for i=1:4;
%         samp(i) =abs(interp1(t,spl(:,i),t_sample));
%     end
% 
%     plot(l,samp*2,char(j),'MarkerSize',20)
%     legend('measured amplitudes','walls','theoretical wave amplitude shape','Comsol wave amplitude shape',lgnd)
%         ylabel('Amplitude [Pa]')
%     xlabel('length [m]')
%     hold off
% end
% 
% 
% end


