function [] = plot_l_858 (freq)

clearvars -except freq

close all
clc


spl=load(['Freq_scan_07_05_2014\mic_volt_858_', num2str(freq),'.lvm.txt']);
% comsol_p=load('total_acoustic_pressure_560mm_mic1_axis.txt');
% comsol_absp=load('Absolute_acoustic_pressure_560mm_mic1_axis.txt');

    ratio=[1.527,1.504,1.695,1.465];
    %ratio=[1.665,1.505,1.597,1.465]; ORIGINAL RATIOS
    
    
    for k=1:4
        for j=1:length(spl)
           spl(j,k)=spl(j,k)*1000/ratio(k);
        end
    end

n=length(spl);
dt=0.5*3.906250E-5;
t=(0:n-1)*dt;

figure(1)
hold all
title('Time Plot, 858 mm chamber')
xlabel('t [s]')
ylabel('Acoustic Pressure [Pa]')

for i=1:4
plot(t,spl(:,i))
end
legend('Microphone 1 (9mm)','Microphone 2 (140mm)','Microphone 3 (274mm)','Microphone 4 (408mm)')

hold off

figure(2)
hold all
title('Spectrum: Acoustic Pressure')
ylabel('Power')
xlabel('Frequency [Hz]')

for i=1:1
    fs=1/dt;                   %sample frequency
    np = pow2(nextpow2(n*4)); % Transform length
    y = fft(spl(:,i),np);      % DFT
    f = (0:np-1)*(fs/np);      % Frequency range
    power = y.*conj(y)/np;     % Power of the DFT
    plot(f,power);
    %TEST
    mxpwr=find(power==max(power));
    ph4se(i)=(atan2(imag(y(mxpwr(1))),real(y(mxpwr(1)))));
end
hold off

amps=zeros(4,1);
amp=0;
t_amp=0;

for i=1:4
    amps(i)=std(spl(:,i));
end

l=[0.008 0.432 0.552 0.713];

chaml=0.8575;
lcham=[0,0.00001, 0.000011, chaml-0.00001, chaml, chaml-0.00001];
wall=max(amps)*1.5;
cham=[0,wall,0,0,wall,0];

ltheo=[0:1000]*chaml/1000;
theo=abs(max(amps)*cos(ltheo*2*pi/chaml));


figure(3)
plot(l,amps,'x','MarkerSize',20)
hold all
plot(lcham, cham)
plot(ltheo,theo);

    ylabel('Amplitude [Pa]')
    xlabel('length [m]')
%SAMPLE OF DATA FROM SAME instant

legend('measured amplitudes','walls','theoretical wave amplitude shape','Comsol wave amplitude shape')

% samp=zeros(4,1);
% char=['+','o','*','h'];
% for j=1:4
%     
%     lgnd=['Wave sample at maximum of microphone ',num2str(j)];
%     figure(j+3)
%     plot(l,amps,'x','MarkerSize',20)
%     hold all
%     plot(lcham, cham)
%     plot(ltheo,theo);
% %     plot(comsol_absp(:,1),comsol_absp(:,2)*max(amps)/max(comsol_absp(:,2)));
%     
%     [t_amp amp]=find_amp(t, spl(:,j));
%     
%     t_sample=t_amp(4);
%     for i=1:4;
%         samp(i) =abs(interp1(t,spl(:,i),t_sample));
%     end
% 
%     plot(l,samp*2,char(j),'MarkerSize',20)
%     legend('measured amplitudes','walls','theoretical wave amplitude shape','Comsol wave amplitude shape',lgnd)
%     hold off
%         ylabel('Amplitude [Pa]')
%     xlabel('length [m]')
% end
% 


